function Section(option) {
    this.title = option.title;
    this.textList = option.textList;
    this.el = document.createElement('div');
    this.init();
}
Section.prototype = {
    init() {
        this.el.appendChild(this.createTitleElement(this.title));
        this.el.appendChild(this.createParagraphElement(this.textList));
    },
    createTitleElement(title) {
        const titleEl = document.createElement('h2');
        titleEl.className = 'title';
        titleEl.textContent = title;
        return titleEl;
    },
    createParagraphElement(textList) {
        const p = document.createElement('p');
        p.className = 'description';
        let html = '';
        textList.forEach((text, i) => {
            html += text;
            if (i !== textList.length) {
                html += '<br>';
            }
        });
        p.innerHTML = html;
        return p;
    }
}